{                       Written by SoulBurner in BP7.0                       }

Program HyperUUE; { HyperUUE 1.01 by SoulBurner }
{----------------------------------------------------------------------------}
{Uses RunTime;
{----------------------------------------------------------------------------}
Const
          ver = '1.01';
{----------------------------------------------------------------------------}
Type
       Fstruct = record
                   name: string[13]; { file name   }
                    len: longint;    { file length }
                   time: longint;    { file time   }
                 end;
{----------------------------------------------------------------------------}
Var
      f: text;
    s,p: string;
    fls: array[1..255] of Fstruct;
  fls_n: byte;
{----------------------------------------------------------------------------}
Procedure Error(s: string);

Begin

  WriteLn(s); Halt;

End;
{----------------------------------------------------------------------------}
Procedure ShowHelp;

Begin

  WriteLn('   Usage:  hyperuue <command> [switches] <filename.ext> [<[@]filename2.ext>...]');
  WriteLn('Commands:  l - List UUE-file');
  WriteLn('           e - Extract <filename2.ext> from <filename.ext> UUE section');
  WriteLn('Switches: /c - Use Connect output standart for listing');
  WriteLn('    Note: You can use "@" in <filename2.ext> to opetare with filelist.');
  WriteLn;
  Halt;

End;
{----------------------------------------------------------------------------}
Procedure UUDecode(fn: string);

Const
  SP = Byte(' ');

  Type
  TTriplet = Array[0..2] of Byte;
  TKwartet = Array[0..3] of Byte;

var f: Text;
    S : File;
    g: File of Byte;
    FileName: String[12];
    Buffer: String;
    Kwartets: record
                lengte: Byte;
                aantal: Byte;
                kwart: Array[1..64] of TKwartet;
              end absolute Buffer;
    Trip: TTriplet;
    i: Integer;
    Fs,CurSize : LongInt;
    FUNCTION UpperStr(S : STRING) : STRING;
    VAR sLen : BYTE ABSOLUTE S;
        I    : BYTE;
    BEGIN
    FOR I := 1 TO sLEN DO S[i] := UpCase(S[i]);
    UpperStr := S;
    END;

    procedure Kwartet2Triplet(Kwartet: TKwartet; var Triplet: TTriplet);
    begin
      Triplet[0] :=  ((Kwartet[0] - SP) SHL 2) +
                    (((Kwartet[1] - SP) AND $30) SHR 4);
      Triplet[1] := (((Kwartet[1] - SP) AND $0F) SHL 4) +
                    (((Kwartet[2] - SP) AND $3C) SHR 2);
      Triplet[2] := (((Kwartet[2] - SP) AND $03) SHL 6) +
                     ((Kwartet[3] - SP) AND $3F)
    end {Kwartet2Triplet};


Begin

  if ParamCount<>3 then ShowHelp;

  Assign(f,ParamStr(2));
  Assign(S,ParamStr(2));
  FileMode := $40;
  reset(f);
  if IOResult<>0 then Error('File not found!');
  Reset(s,1);
  Fs := FileSize(s);
  close(S);
  reset(f);
  repeat
    readln(f,Buffer) { skip }
  until eof(f) or ((Copy(Buffer,1,5)='begin')
        and (Pos(UpperStr(fn),UpperStr(Buffer))<>0));
  if Buffer[11] = #32 then FileName := Copy(Buffer,12,12)
  else
    if Buffer[10] = #32 then FileName := Copy(Buffer,11,12)
                        else FileName := fn;


  Assign(g,FileName);
{  if ParamCount > 1 then
  begin
    FileMode := $02;
    reset(g);
    if IOResult = 0 then
    begin
      writeln('Error: file ',FileName,' already exists.');
      Halt(3)
    end
  end;}
  rewrite(g);
  if IOResult <> 0 then
  begin
    writeln('Error: could not create file ',FileName);
    Halt(4)
  end;
  Write('Extracting "'+fn+'"...');
  CurSize := 0;
  while (not eof(f)) and (Buffer <> 'end') and (Buffer <> '`') do
  begin
    FillChar(Buffer,SizeOf(Buffer),#32);
    readln(f,Buffer);
    CurSize := CurSize+ Byte(Buffer[0]);
    if (Buffer <> 'end') and (Buffer <> '`') then
    begin
      for i:=1 to (Kwartets.aantal-32) div 3 do
      begin
        Kwartet2Triplet(Kwartets.kwart[i],Trip);
        write(g,Trip[0],Trip[1],Trip[2])
      end;
      if ((Kwartets.aantal-32) mod 3) > 0 then
      begin
        Kwartet2Triplet(Kwartets.kwart[i+1],Trip);
        for i:=1 to ((Kwartets.aantal-32) mod 3) do write(g,Trip[i-1])
      end
    end

  end;
  close(f);
  close(g);
  WriteLn('O.K.');
{  if ParamCount >= 1 then
    writeln('UUDeCoded file ',FileName,' created.');}

end;
{----------------------------------------------------------------------------}
Function UpCaseStr(s: string): string;

Var
     s2: string;
      i: byte;

Begin

  s2:='';
  for i:=1 to Length(s) do
    s2:=s2+UpCase(s[i]);
  UpCaseStr:=s2;

End;
{----------------------------------------------------------------------------}
Procedure List;

Var
     key_c: boolean;
         n: string;
         l: longint;
         t: longint;
         i: byte;
        ff: boolean;

Begin

  key_c:=false;
  s:=UpCaseStr(ParamStr(2));
  if (s[1] in ['-','/']) and (s[2]='C') then
  begin
    key_c:=true;
    s:=UpCaseStr(ParamStr(3));
  end;

  if s='' then ShowHelp;

  Assign(f,s); {$I-} Reset(f); {$I+}
  if IOResult<>0 then Error('File not found!');

  while not Eof(f) do
  begin
    ReadLn(f,s);
    s:=UpCaseStr(s);
    if (Pos('SECTION',s)<>0) and (Pos('OF FILE',s)<>0) then
    begin
      n:=Copy(s,Pos('OF FILE',s)+8,255);
      while n[1]=' ' do n:=Copy(n,2,255);
      if Pos(' ',n)<>0 then n:=Copy(n,1,Pos(' ',n)-1);

      while Length(n)<13 do n:=n+' ';
      ff:=false;
      for i:=1 to fls_n do
        ff:=ff or (fls[i].name=n);

      if not ff then
      begin
        Inc(fls_n); fls[fls_n].name:=n;
      end;

    end;
  end;

  for i:=1 to fls_n do
  begin
    if key_c then WriteLn(fls[i].name)
             else WriteLn('  name: ',fls[i].name);
  end;

End;
{----------------------------------------------------------------------------}
Begin

  if ParamStr(1)='!getversionnumber' then
  begin
    WriteLn(ver); Halt;
  end;

  fls_n:=0;

  if ParamCount<2 then begin
                         WriteLn('HyperUUE '+ver+' by SoulBurner'); WriteLn;
                         ShowHelp;
                       end;
  s:=ParamStr(2);
  if not ((s[1] in ['-','/']) and (UpCase(s[2]) in ['C','C'])) then
    WriteLn('HyperUUE '+ver+' by SoulBurner');

  s:=UpCaseStr(ParamStr(1));

  case s[1] of
    'L': List;
    'E': begin
           s:=ParamStr(3);
           if s[1]<>'@' then UUDecode(s)
           else
           begin
             s:=Copy(s,2,255);
             Assign(f,s);
             {$I-} Reset(f); {$I+}
             if IOResult<>0 then Error('Filelist not found!');
             while not Eof(f) do
             begin
               ReadLn(f,s); UUDecode(s);
             end;
             Close(f);
           end;
         end;
  else ShowHelp;
  end;

End.
{----------------------------------------------------------------------------}