{                    Written by SoulBurner in TMT Pascal                     }

Program ZX_Disk;
{----------------------------------------------------------------------------}
Uses sbFile, Dos;
{----------------------------------------------------------------------------}
Const
            ver = '1.02';
 key_c: boolean = false;         { if key "c" is used                        }
{----------------------------------------------------------------------------}
Type

            string8 = array[1..8] of char;

   SpectrumFileType = record
                 name: string8;  {  䠩                                 }
                  ext: char;     { pp                                }
                start: word;     { p 砫 䠩                        }
                  len: word;     {  䠩                        }
                 size: byte;     { pp  ᥪp                         }
      beg_sec,beg_trk: byte;     { 砫 䠩  ᪥ (ᥪp/p)    }
   end;

              FilesT = array[1..255] of SpectrumFileType;

 diskinfoT = record
          freesec: byte;    { 1- ᢮ ᥪp                           }
          freetrk: byte;    { 1- ᢮ p                          }
              typ: byte;    { $16-80/DS   $17-40/DS   $18-80/SS   $19-40/SS  }
            files: byte;    { - 䠩  ᪥                         }
             free: word;    { - ᢮ ᥪp  ᪥             }
           code10: byte;    { = $10                                          }
              del: byte;    { - 㤠 䠩                        }
             name: string8; {  ᪠                                      }
           end;
{----------------------------------------------------------------------------}
Var
        f: file;
      i,j: word;
        y: word;
      par: string;
 ext,n,n2: string;
        p: pointer;
      adj: word;
 diskinfo: diskinfoT;
   spec_f: array[1..255] of SpectrumFileType;
{----------------------------------------------------------------------------}
{ 楤 Sound, NoSound  Delay ᠭ  ⮣, ⮡  㦭 뫮 -
  ⮬ Crt, ..   ᯮ짮  ७ࠢ 뢮 
 䠩 }

Procedure Sound(Hz: Word);
(*Turn on the sound at the designated frequency*)
Begin

  Asm
        MOV     BX,Hz                  (*BX = Hz       *)
        MOV     AX,34DCh
        MOV     DX,0012h               (*DX:AX = $1234DC = 1,193,180 *)
        CMP     DX,BX                  (*Make sure the division won't *)
        JAE     @SoundExit             (* produce a divide by zero error *)
        DIV     BX                     (*Count (AX) = $1234DC div Hz     *)
        MOV     BX,AX                  (*Save Count in BX                *)

        IN      AL,61h                 (*Check the value in port $61     *)
        TEST    AL,00000011b           (*Bits 0 and 1 set if speaker is on *)
        JNZ     @SetCount              (*If they're already on, continue   *)

        OR      AL,00000011b           (*Set bits 0 and 1   *)
        OUT     61h,AL                 (*Change the value   *)
        MOV     AL,182                 (*Tell the timer that the count is coming *)
        OUT     43h,AL                 (*by sending 182 to port $43  *)

@SetCount:
        MOV     AL,BL                  (*Low byte into AL       *)
        OUT     42h,AL                 (*Load low order byte into port $42 *)
        MOV     AL,BH                  (*High byte into AL                 *)
        OUT     42h,AL                 (*Load high order byte into port $42*)

@SoundExit:
  end;

End;{Sound}
{----------------------------------------------------------------------------}
Procedure NoSound; assembler;
(* Turn off the sound *)
Asm

        IN      AL,61h                  (* Get current value of port $61 *)
        AND     AL,11111100b            (* Turn off bits 0 and 1         *)
        OUT     61h,AL                  (* Reset the port                *)

End; {NoSound}
{----------------------------------------------------------------------------}
Procedure Delay(n: longint);

Var
     l1,l2: longint;
   h,m,s,t: word;

Begin

  GetTime(h,m,s,t);
  l1:=Longint(h)*36000+m*6000+s*100+t;
  repeat
    GetTime(h,m,s,t);
    l2:=Longint(h)*36000+m*6000+s*100+t;
  until (l2-l1)>=n;

End;
{----------------------------------------------------------------------------}
Function UpCaseStr(s: string): string;

Var
     i: byte;
    s2: string;

Begin

  s2:='';
  for i:=1 to Length(s) do
    s2:=s2+UpCase(s[i]);

  UpCaseStr:=s2;

End;
{----------------------------------------------------------------------------}
Procedure Error(s: string);

Begin

  {$I-} Close(f); {$I+}
  Sound(1000); Delay(30); NoSound;
  WriteLn(s); Halt(4);

End;
{----------------------------------------------------------------------------}
Procedure ShowHelp;

Begin

  WriteLn('   Usage: zx_disk <command> [-<switch> [-<switch>]] <file1.ext> [<file2.ext>]');
  WriteLn('Commands:  l - list contents of disk image <file1.ext>');
  WriteLn('           e - extract file <file2.ext> from disk image <file1.ext>');
  WriteLn('           a - add file <file2.ext> to disk image <file1.ext>');
  WriteLn('           m - move file <file2.ext> to disk image <file1.ext>');
  WriteLn('Switches: -c - use Connect output style');
  WriteLn('    Note: You can use "@" in <file2.ext> to opetare with filelist.');
  WriteLn;
  Halt;

End;
{----------------------------------------------------------------------------}
Function ConvertString(s: string): string;

Var
    s2: string;
     i: byte;

Begin

  { ⠡ ४஢ ᨬ }

  s2:='';
  for i:=1 to Length(s) do
    case s[i] of
      '.',',': s2:=s2+'';
          ' ': s2:=s2+#255;
          '*': s2:=s2+'';
          '+': s2:=s2+'';
          '?': s2:=s2+'';
          ':': s2:=s2+'';
          ';': s2:=s2+'';
          '=': s2:=s2+'';
          '"': s2:=s2+'`';
          else s2:=s2+s[i]
    end;

  ConvertString:=s2;

End;
{----------------------------------------------------------------------------}
Function OpenTRDFile(name: string): boolean;

Var
    a: boolean;
  buf: SpectrumFileType;
    s: string;
  i,j: byte;

Begin

  a:=sbOpenFileforReading(f,name);
  OpenTRDFile:=a;
  if not a then Error('Error opening .TRD file!');
  Seek(f,adj);

  for i:=1 to 128 do
  begin
    BlockRead(f,spec_f[i],16);
  end;

  Seek(f,$8E1+adj);
  BlockRead(f,diskinfo,SizeOf(diskinfo));

End;
{----------------------------------------------------------------------------}
Procedure ExtractTRD(s: string);

Var
     i,j: word;
       a: string;
      ff: file;
     w,l: word;

Begin

  for j:=1 to diskinfo.files+diskinfo.del do
  begin
    a:=spec_f[j].name;
    while a[Length(a)]=' ' do a:=Copy(a,1,Length(a)-1);
    a:=ConvertString(a);
    a:=a+'.$'+ConvertString(spec_f[j].ext);
    if s=a then Break;
  end;

  if s<>a then Error('File not found in disk image!');

  Assign(ff,s); Rewrite(ff,1);
  BlockWrite(ff,spec_f[j],13); { write hobeta header }
  l:=0; BlockWrite(ff,l,1); { write reserved byte }
  BlockWrite(ff,spec_f[j].size,3);

  Seek(f,Longint(spec_f[j].beg_trk*16+spec_f[j].beg_sec)*256+adj);
  l:=spec_f[j].size*256; { file size in bytes }
  repeat
    if l>10000 then w:=10000 else w:=l;
    BlockRead(f,p^,w); l:=l-w;
    BlockWrite(ff,p^,w);
  until l=0;
  Close(ff);

End;
{----------------------------------------------------------------------------}
Procedure DeleteTRD(s: string);

Var
     i,j: word;
       a: string;
     w,l: word;
      sz: dword;

Begin

  for j:=1 to diskinfo.files+diskinfo.del do
  begin
    a:=spec_f[j].name;
    while a[Length(a)]=' ' do a:=Copy(a,1,Length(a)-1);
    a:=ConvertString(a);
    a:=a+'.$'+ConvertString(spec_f[j].ext);
    if s=a then Break;
  end;

  if s<>a then Error('File not found in disk image!');

  spec_f[j].name[1]:=#01;
  Dec(diskinfo.files); Inc(diskinfo.del);

  if diskinfo.files=0 then
    with diskinfo do
    begin
      freesec:=0; freetrk:=1; files:=0; del:=0; free:=159*16;
      for i:=1 to 128 do
      begin
        spec_f[i].name:=#0#0#0#0#0#0#0#0;
        spec_f[i].ext:=#0;
      end;
    end;

  Seek(f,0);

  sz:=FileSize(f);
  BlockRead(f,p^,sz);

  FilesT(Mem[Ofs(p^)+adj]):=spec_f;
  DiskInfoT(Mem[Ofs(p^)+adj+$8E1]):=diskinfo;

  Close(f);
  Assign(f,n);
  {$I-} Rewrite(f,1); {$I+}
  if IOResult<>0 then Error('Couldn''t create temporary file!');
  BlockWrite(f,p^,sz);
  Close(f);

  sbOpenFileForReading(f,n);
  Seek(f,adj);

End;
{----------------------------------------------------------------------------}
Procedure AddTRD(s: string);

Var
     i,j: word;
       a: string;
      ff: file;
     w,l: word;
      sz: dword;
      aa: byte;

Begin

  if Pos('.$',s)=0 then Error('File must be of Hobeta-format!');
  if not sbOpenFileForReading(ff,s) then Error('File not found!');
  l:=FileSize(ff)-17;
  if diskinfo.free<(l div 256) then
  begin
    Close(ff);
    Error('Not enough free space!');
  end;

  Inc(diskinfo.files);
  j:=diskinfo.files+diskinfo.del;
  BlockRead(ff,spec_f[j],13); { read hobeta header }
  BlockRead(ff,aa,1); { reserved byte }
  BlockRead(ff,spec_f[j].size,3);
  spec_f[j].beg_trk:=diskinfo.freetrk;
  spec_f[j].beg_sec:=diskinfo.freesec;
  spec_f[j+1].name[1]:=#0;
  Dec(diskinfo.free,spec_f[j].size);

  Seek(f,0);

  sz:=FileSize(f);
  BlockRead(f,p^,sz);

  w:=Word(diskinfo.freetrk)*16+diskinfo.freesec;

  BlockRead(ff,Mem[Ofs(p^)+adj+Dword(w)*256],l);

  l:=l div 256;
  w:=w+l;

  diskinfo.freetrk:=w div 16;
  diskinfo.freesec:=w mod 16;

  FilesT(Mem[Ofs(p^)+adj]):=spec_f;
  DiskInfoT(Mem[Ofs(p^)+adj+$8E1]):=diskinfo;

  Close(f); Close(ff);
  Assign(f,n);
  {$I-} Rewrite(f,1); {$I+}
  if IOResult<>0 then Error('Couldn''t create temporary file!');
  BlockWrite(f,p^,sz);
  Close(f);

  sbOpenFileForReading(f,n);
  Seek(f,adj);

End;
{----------------------------------------------------------------------------}
Procedure Operate_TRD;

Var
    p: char;
  s,a: string;
  i,j: word;
   fl: text;

Begin

  s:=ParamStr(1); p:=UpCase(s[1]);

  case p of
    'L': begin
           OpenTRDFile(n);
           if not key_c then
           begin
             WriteLn('Label: ',diskinfo.name,'    files: ',diskinfo.files:3,
                     '    deleted: ',diskinfo.del,'    free: ',diskinfo.free*255:5);
             WriteLn('Ŀ');
           end;

           for i:=1 to diskinfo.files+diskinfo.del do
             if spec_f[i].name[1]>#1 then
               if key_c then
               begin
                 a:=spec_f[i].name;
                 while a[Length(a)]=' ' do a:=Copy(a,1,Length(a)-1);
                 a:=ConvertString(a);
                 with spec_f[i] do
                   WriteLn(a+'.$'+ConvertString(ext),' ',size*256);
               end
               else
                 WriteLn('name: ',spec_f[i].name+'.$'+spec_f[i].ext,
                         ' len: ',spec_f[i].len:5,
                         ' size: ',spec_f[i].size:3,'s.',
                         'begin: ',spec_f[i].start:5,' trk: ',
                         spec_f[i].beg_trk:2,' sec: ',spec_f[i].beg_sec:2,' ');

           if not key_c then
             WriteLn('');

         end; { list command }

    'E': begin
           OpenTRDFile(n);
           if n2='' then Error('No file specified!');
           if (Pos('.',n2)=0) and (Pos('@',n2)=0) then Error('No extension specified!');
           if n2[1]='@' then
           begin { filelist }
             Assign(fl,Copy(n2,2,255));
             {$I-} Reset(fl); {$I+}
             if IOResult<>0 then Error('Error opening filelist!');
             while not Eof(fl) do
             begin
               ReadLn(fl,n2);
               ExtractTRD(n2);
             end;
             Close(fl);
           end
           else
             ExtractTRD(n2);
         end; { extract command }

    'D': begin
           OpenTRDFile(n);
           if n2='' then Error('No file specified!');
           if (Pos('.',n2)=0) and (Pos('@',n2)=0) then Error('No extension specified!');
           if n2[1]='@' then
           begin { filelist }
             Assign(fl,Copy(n2,2,255));
             {$I-} Reset(fl); {$I+}
             if IOResult<>0 then Error('Error opening filelist!');
             while not Eof(fl) do
             begin
               ReadLn(fl,n2);
               DeleteTRD(n2);
             end;
             Close(fl);
           end
           else
             DeleteTRD(n2);
         end; { delete command }

    'A': begin
           OpenTRDFile(n);
           if n2='' then Error('No file specified!');
           if (Pos('.',n2)=0) and (Pos('@',n2)=0) then Error('No extension specified!');
           if n2[1]='@' then
           begin { filelist }
             Assign(fl,Copy(n2,2,255));
             {$I-} Reset(fl); {$I+}
             if IOResult<>0 then Error('Error opening filelist!');
             while not Eof(fl) do
             begin
               ReadLn(fl,n2);
               AddTRD(n2);
             end;
             Close(fl);
           end
           else
             AddTRD(n2);
         end; { add command }

    'M': begin
           OpenTRDFile(n);
           if n2='' then Error('No file specified!');
           if (Pos('.',n2)=0) and (Pos('@',n2)=0) then Error('No extension specified!');
           if n2[1]='@' then
           begin { filelist }
             Assign(fl,Copy(n2,2,255));
             {$I-} Reset(fl); {$I+}
             if IOResult<>0 then Error('Error opening filelist!');
             while not Eof(fl) do
             begin
               ReadLn(fl,n2);
               AddTRD(n2); sbErase(n2);
             end;
             Close(fl);
           end
           else
           begin
             AddTRD(n2); sbErase(n2);
           end;
         end; { move command }

  end; { case }


End;
{----------------------------------------------------------------------------}
Procedure Operate_FDI;

Var
     f2: file;

Begin

  if not sbOpenFileForReading(f2,n) then Error('Image file not found!');
  Seek(f2,$0A);
  BlockRead(f2,adj,2);
  Close(f2);
  Operate_TRD;

End;
{----------------------------------------------------------------------------}
Begin

  adj:=0;

  par:='';
  for i:=1 to ParamCount do par:=par+ParamStr(i)+' ';
  for i:=1 to Length(par) do if par[i]='/' then par[i]:='-';
  par:=UpCaseStr(par);

  if Pos('-C ',par)=0 then
  begin
    WriteLn('ZX Disk Utilities '+ver+' by SoulBurner.');
    n:=UpCaseStr(ParamStr(2)); n2:=ParamStr(3);
  end
  else begin
    key_c:=true;
    n:=UpCaseStr(ParamStr(3)); n2:=ParamStr(4);
  end;

  GetMem(p,2000000);

  if (not key_c and (ParamCount<2)) or (key_c and (ParamCount<3)) or
     (Pos('.',par)=0) then ShowHelp; { syntax error }

  ext:=Copy(par,Pos('.',par)+1,3);

  if ext='TRD' then Operate_TRD
  else
    if ext='FDI' then Operate_FDI
      else Error('Wrong disk image extension!');

  {$I-} Close(f); {I+}

End.
{----------------------------------------------------------------------------}